//+================================================================================================
//+ Author  : Richard VK4XRL, Mike G7GTN
//+ Version : 1.00
//+ Date    : September 2018
//+================================================================================================
//+
//+ Purpose :
//+              Test (4X3) Keypad on I2C PCF8574 LCD Module
//+
//+
//+
//+================================================================================================

#include <Wire.h>

#define I2CADDRLCD 0x27                   // I2C LCD Hexadecimal Address Of eBay PCF8574A Backpack Device. This can also be (0X3F) by default
#define I2CADDRKEYPADLCDMODULE 0x20       // Keypad on standard un-modified LCD Backpack Module. Change for your modules set PCF8574 I2C address

#include <Keypad_I2C.h>
#include <Keypad.h>
const byte ROWS = 4;      // Four rows
const byte COLS = 3;      // Three columns
char keys[ROWS][COLS] = {
  {'1','2','3'},
  {'4','5','6'},
  {'7','8','9'},
  {'*','0','#'}
};
// Matrix keypad, bit numbers of LCD PCF8574 I/O port
 byte rowPins[ROWS] = {0, 1, 2, 4};   // Connect to the Row pinouts of the keypad
 byte colPins[COLS] = {5, 6, 7};      // Connect to the Column pinouts of the keypad
 
// Matrix Keypad dedicated PCF8574 Module
// byte rowPins[ROWS] = {0, 1, 2, 3};   // Connect to the Row pinouts of the keypad
// byte colPins[COLS] = {4, 5, 6};      // Connect to the Column pinouts of the keypad 

Keypad_I2C kpd( makeKeymap(keys), rowPins, colPins, ROWS, COLS, I2CADDRKEYPADLCDMODULE, PCF8574 );

#include <LCD.h>
#include <LiquidCrystal_I2C.h>
#define BACKLIGHT_PIN     3
#define En_pin  2
#define Rw_pin  1
#define Rs_pin  0
#define D4_pin  4
#define D5_pin  5
#define D6_pin  6
#define D7_pin  7
LiquidCrystal_I2C lcd(I2CADDRLCD,En_pin,Rw_pin,Rs_pin,D4_pin,D5_pin,D6_pin,D7_pin);

//
void setup()
{
  kpd.begin( makeKeymap(keys) );                // Start keypad
  lcd.begin (16,2); 
  lcd.setBacklightPin(BACKLIGHT_PIN,POSITIVE);	// Switch on LCD backlight
  lcd.setBacklight(HIGH);
  lcd.clear();    
  lcd.setCursor(0,0);                                  
  lcd.print(" PRESS A KEY");
}

//-----------------------------------------------------------------------
// Read matrix keypad via PCF8574 Module
//-----------------------------------------------------------------------
void readkeypad()
 {
  char key = kpd.getKey(); 
  if (key) //  != NO_KEY)
    switch(key)
    {
    case '0':                        
      lcd.setCursor(0,1);                                  
      lcd.print("KEY 0       ");
      break;       
    case '1': 
      lcd.setCursor(0,1);                                  
      lcd.print("KEY 1       "); 
      break;    
    case '2':
      lcd.setCursor(0,1);                                  
      lcd.print("KEY 2       ");
      break;
    case '3':
      lcd.setCursor(0,1);                                  
      lcd.print("KEY 3       ");
      break;
    case '4':
      lcd.setCursor(0,1);                                  
      lcd.print("KEY 4       ");
      break;
    case '5':
      lcd.setCursor(0,1);                                  
      lcd.print("KEY 5       "); 
      break;
    case '6':
      lcd.setCursor(0,1);                                  
      lcd.print("KEY 6       ");
      break;
    case '7':
      lcd.setCursor(0,1);                                  
      lcd.print("KEY 7       ");
      break;      
    case '8':
      lcd.setCursor(0,1);                                  
      lcd.print("KEY 8       ");
      break;
    case '9':
      lcd.setCursor(0,1);                                  
      lcd.print("KEY 9       ");    
      break;
    case '*':
      lcd.setCursor(0,1);                                  
      lcd.print("KEY *       ");      
      break;     
    case '#':
      lcd.setCursor(0,1);                                  
      lcd.print("KEY #       ");     
      break;  
 }  
}

//
void loop()
{
  readkeypad();		// Keep reading keypad
}